#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include<math.h> 

#define N 100001 //ノード数の定義
#define E 200001 //エッジ数の定義
#define BB 4 //ノイズの定義(4,3.37,2,84)
#define AM 30.0 //利得の値 100
#define BM 20.0 //20 30
#define CM 15.0 //15 20
#define DM 10.0 //5 15

inline void InitRand() //timeで乱数
{
    srand((unsigned int)time(NULL));
}


int main(){
	int i=1,k=1,node_number=1;
	static int a[E]={0};
	static int b[E]={0};
	static int c[N]={0};
	static int d[N]={0};
	static double e[N]={0};
	static int f[N]={0};
	static int ab[N][3000]={0};
	double am=AM,bm=BM,cm=CM,dm=DM;
	double B=BB;
	
	FILE *fp;
	char s[100];
	char file[100];
	int ret, ii=1;
	
	printf("file:"); //ファイルの読み込み
	scanf("%s",file);
	fp = fopen( file , "r" );
	if( fp == NULL ){ //ファイル読み込み不可の場合
		printf( "NO File¥n");
		return -1;
	}
	
	while( ( ret = fscanf( fp, "%d %d",&a[ii], &b[ii] 
						  ) ) != EOF ){  //txtファイル用
		ii++;
	}
	fclose( fp );
	
	double p=0.16; //初期設定の確率16%
	InitRand();
	for(int m=1;m<N;m++){ //ノードの初期状態の配置
		if( (double)rand()/RAND_MAX < p ){
			c[m]=1;
			f[m]=1;
		} else{
			c[m]=-1;
			f[m]=-1;
		} 
	}
	
	for(int i=1;a[i]!=0;i++){ //a[]とb[]の探索
		d[a[i]]++;
		d[b[i]]++;
		ab[a[i]][d[a[i]]]=b[i];
		ab[b[i]][d[b[i]]]=a[i];
	}
	
	
    node_number=1; 
    int x,y=0,Tt,total=0,tm;
    double probability,pi,pi2,h,t=0;
    double hi,kk,xj,k2=0;
    h=(am-dm-bm+cm)/(am-dm+bm-cm); //hの計算(論文)
	
	for(int z=1;z<=100;z++){
		for(int n=1;;n++){
			while(node_number < N) { //周りのノードを探索
				for(k=1;ab[node_number][k]>0;k++){
					x=f[ab[node_number][k]];
					k2++;
					if(x==1){ //利得の計算
						tm=am-dm;
						t+=tm;
					}else if(x==-1){
						tm=bm-cm;
						t-=tm;
					}
					y+=x;
				}
				e[node_number]=y;
				y=0;
				if(t>=0){ //利得合計がプラスの場合
					c[node_number]=1;
					hi=k2*h;  xj=e[node_number];
					pi = B*(hi + xj); pi2 = -1*B*(hi + xj);
					probability = 1.0-(exp( pi ) / ( exp( pi ) + exp( pi2 ) )); //論文の式１
					if( (double)rand()/RAND_MAX < probability ){ //ノイズの影響
						c[node_number]= -1;    
					}
				} else { //利得合計がマイナスの場合
					c[node_number]= -1;
					hi=k2*h;  xj=e[node_number];
					pi = B*(hi + xj);  pi2 = -1*B*(hi + xj);
					probability = 1.0- (exp( pi2 ) / ( exp( pi ) + exp( pi2 ) )); //論文の式１
					if( (double)rand()/RAND_MAX < probability ){ //ノイズの影響
						c[node_number]= 1;
					}
				}
				
				probability = 0.0; k2=0.0; hi=0.0; xj=0.0; pi=0.0; pi2=0.0;				
				total+=c[node_number];
				if(total==N-1){
					Tt = n;
					printf("%d\n",Tt); //T+の出力(データ採取の場合は%dのみで出力)
					break;
				}
				else if(n==20001){ //T+を２万で打ち止め
					Tt = 20001;
					printf("%d\n",Tt);
				}
				
				e[node_number]=0;
				node_number++;   
				t=0;
			}
			if (total==N-1) break;
			InitRand();
			total = 0;
			node_number=1;
			for(int l=1;l<=N;l++)
				f[l]=c[l];
		}
		e[node_number]=0; t=0; total=0; node_number=1;
		for(int m=1;m<N;m++){ //ノードの次の状態の配置
			if( (double)rand()/RAND_MAX < p ){
				c[m]=1;
				f[m]=1;
			} else{
				c[m]=-1;
				f[m]=-1;
			} 
		}
		
	}
	
	return 0;
}
